﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;


namespace Hotel
{
    public partial class DBNumbers : Form
    {
        SqlDataAdapter dataAdapter;
        DataSet dataSet;
        public DBNumbers()
        {
            InitializeComponent();
        }

        private void b_back_Click(object sender, EventArgs e)
        {
            Main_menu_admin newForm = new Main_menu_admin();
            this.Hide();
            newForm.Show();
        }

        private void b_add_Click(object sender, EventArgs e)
        {
            Numbers newForm = new Numbers();
            this.Hide();
            newForm.Show();

        }

        private void DBNumbers_FormClosing(object sender, FormClosingEventArgs e)
        {
            Application.Exit();
        }

        private void DBNumbers_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "_31P_HotelDataSet.Numbers". При необходимости она может быть перемещена или удалена
            const string sql = "SELECT Kod_number as 'Код', Nom as 'Номер', [Number_of_seats] as 'Количество мест', Price as 'Стоимость', TV as 'TV', WiFi as 'Wi-Fi', Conditioner as 'Кондиционер' From Numbers";
            using (SqlCommand sqlCommand = new SqlCommand(sql, database.connection()))
            {
                try
                {
                    using (SqlDataReader dataReader = sqlCommand.ExecuteReader())
                    {
                        DataTable dataTable = new DataTable();
                        dataTable.Load(dataReader);
                        this.dataGridViewNumb2.DataSource = dataTable;
                        dataReader.Close();
                    }
                }
                catch
            {
                MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        }

        private void b_update_Click(object sender, EventArgs e)
        {
            const string sql = "SELECT Kod_number as 'Код', Nom as 'Номер', [Number_of_seats] as 'Количество мест', Price as 'Стоимость', TV as 'TV', WiFi as 'Wi-Fi', Conditioner as 'Кондиционер' From Numbers";
            using (SqlCommand sqlCommand = new SqlCommand(sql, database.connection()))
            {
                try
                {
                    using (SqlDataReader dataReader = sqlCommand.ExecuteReader())
                    {
                        DataTable dataTable = new DataTable();
                        dataTable.Load(dataReader);
                        this.dataGridViewNumb2.DataSource = dataTable;
                        dataReader.Close();
                    }
                }
                catch
                {
                    MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void dataGridViewNumb_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string row = dataGridViewNumb2.Rows[dataGridViewNumb2.CurrentCell.RowIndex].Cells[0].Value.ToString();
                SqlCommand a = new SqlCommand($"delete from Numbers where Kod_number = {row} ", database.connection());
                a.ExecuteNonQuery();
            }
            catch
            {
                MessageBox.Show("Данные используются в другом документе!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            dataGridViewNumb2.Refresh();
            DBNumbers nn = new DBNumbers();
            this.Hide();
            nn.Show();
        }
    }
}
