﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Hotel
{
    public partial class Employees : Form

    {
        SqlDataAdapter dataAdapter;
        DataSet dataSet;
        public Employees()
        {
            InitializeComponent();

        }

        private void b_back_Click(object sender, EventArgs e)
        {
            Main_menu_admin newForm = new Main_menu_admin();
            this.Hide();
            newForm.Show();
        }

        private void b_update_Click(object sender, EventArgs e)
        {
            //SqlCommand zapros = new SqlCommand($"insert into [Employees] (Surname, [Name], Patronymic, Phone, Kod_role, Birthday, Password, Login) values (@Surname, @Name, @Patronymic, @Phone, @Kod_role, @Birthday, @Password, @Login)", database.connection());
            const string sql = "SELECT Employees.Kod_employee as 'Код', Employees.Surname as 'Фамилия', Employees.Name as 'Имя', Employees.Patronymic as 'Отчетсво', Employees.Phone as 'Номер телефона', Role.Role as 'Роль', Employees.Birthday as 'День рождения', Employees.Password as 'Пароль', Employees.Login as 'Логин'  From Employees left outer join Role on Role.Kod_role = Employees.Kod_role";
            using (SqlCommand sqlCommand = new SqlCommand(sql, database.connection()))
            {
                try
                {
                    using (SqlDataReader dataReader = sqlCommand.ExecuteReader())
                    {
                        DataTable dataTable = new DataTable();
                        dataTable.Load(dataReader);
                        this.dataGridView_employee.DataSource = dataTable;
                        dataReader.Close();
                    }
                }
                catch
                {
                    MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void b_add_Click(object sender, EventArgs e)
        {
            Employees_add newForm = new Employees_add();
            this.Hide();
            newForm.Show();
        }

        private void Employees_FormClosing(object sender, FormClosingEventArgs e)
        {
            Application.Exit();
        }

        private void Employees_Load(object sender, EventArgs e)
        {
            const string sql = "SELECT Employees.Kod_employee as 'Код', Employees.Surname as 'Фамилия', Employees.Name as 'Имя', Employees.Patronymic as 'Отчетсво', Employees.Phone as 'Номер телефона', Role.Role as 'Роль', Employees.Birthday as 'День рождения', Employees.Password as 'Пароль', Employees.Login as 'Логин'  From Employees left outer join Role on Role.Kod_role = Employees.Kod_role";
            using (SqlCommand sqlCommand = new SqlCommand(sql, database.connection()))
            {
                try
                {
                    using (SqlDataReader dataReader = sqlCommand.ExecuteReader())
                    {
                        DataTable dataTable = new DataTable();
                        dataTable.Load(dataReader);
                        this.dataGridView_employee.DataSource = dataTable;
                        dataReader.Close();
                    }
                }
                catch
                {
                    MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string row = dataGridView_employee.Rows[dataGridView_employee.CurrentCell.RowIndex].Cells[0].Value.ToString();
                SqlCommand a = new SqlCommand($"delete from Employees where Kod_employee = {row} ", database.connection());
                a.ExecuteNonQuery();
            }
            catch
            {
                MessageBox.Show("Данные используются в другом документе!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            dataGridView_employee.Refresh();
            Employees nn = new Employees();
            this.Hide();
            nn.Show();
        }
    }


}
    
