﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Hotel
{
    public partial class Employees_add : Form
    {
        public Employees_add()
        {
            InitializeComponent();
            const string sql = "Select * from Role;";
            DataTable table = new DataTable();
            SqlCommand cmd = new SqlCommand(sql, database.connection());
            SqlDataAdapter adapter = new SqlDataAdapter();
            adapter.SelectCommand = cmd;
            adapter.Fill(table);
            DataRow[] rows = table.Select();
            for (int i = 0; i < table.Rows.Count; i++)
            {
                comboBox_post.Items.Insert(i, rows[i]["Role"]);
            }
        }

        private void b_save_Click(object sender, EventArgs e)
        {
            try
            {
                SqlCommand check1 = new SqlCommand($"select count(*) from [Employees] where [Login] like '{t_login.Text}'", database.connection());
                //SqlCommand check2 = new SqlCommand($"select count(*) from [autorizathion] where [password] like '{textBox2.Text}'", sqlConnection);
                t_login.Text = t_login.Text.Trim();
                t_pass.Text = t_pass.Text.Trim();

                t_name.Text = t_name.Text.Trim();
                t_surname.Text = t_surname.Text.Trim();
                t_pat.Text = t_pat.Text.Trim();
                comboBox_post.Text = comboBox_post.Text.Trim();
                maskedPhone.Text = maskedPhone.Text.Trim();
                date.Text = date.Text.Trim();
                if (check1.ExecuteScalar().ToString() == "0")
                {
                    if (t_login.Text == "" || t_pass.Text == "" || t_name.Text == "" || t_surname.Text == "" || t_pat.Text == "" || comboBox_post.Text == "" || maskedPhone.Text == "" || date.Text == "")
                    {
                        MessageBox.Show("Поля не заполнены!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    else
                    {
                        if (t_pass.Text.Length < 6)
                        {
                            MessageBox.Show("Пароль слишком маленький!\nВведите не менее 6 символов", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                        else
                        {
                            if (t_login.Text.Contains(" ") || t_pass.Text.Contains(" "))
                            {
                                MessageBox.Show("В логине или пароле не должно быть пробелов!\nУдалите все пробелы и повторите попытку", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            else if (t_name.Text.Contains(" ") || t_surname.Text.Contains(" ") || t_pat.Text.Contains(" "))
                            {
                                MessageBox.Show("В заполненных данных не должно быть пробелов!\nУдалите все пробелы и повторите попытку", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            else
                            {
                                int mat = 0;
                                const string sql1 = "Select * from Role;";
                                DataTable table1 = new DataTable();
                                SqlCommand cmd1 = new SqlCommand(sql1, database.connection());
                                SqlDataAdapter adapter1 = new SqlDataAdapter();
                                adapter1.SelectCommand = cmd1;
                                adapter1.Fill(table1);
                                DataRow[] rows1 = table1.Select();
                                for (int i = 0; i < table1.Rows.Count; i++)
                                {
                                    if (Convert.ToString(rows1[i]["Role"]) == comboBox_post.Text)
                                    {
                                        mat = (int)rows1[i]["Kod_role"];
                                    }
                                }

                                SqlCommand zapros = new SqlCommand($"insert into [Employees] (Surname, [Name], Patronymic, Phone, Kod_role, Birthday, Password, Login) values (@Surname, @Name, @Patronymic, @Phone, @Kod_role, @Birthday, @Password, @Login)", database.connection());

                                string dateTime = date.Value.ToString("yyyy-MM-dd");
                                zapros.Parameters.AddWithValue("Login", t_login.Text);
                                zapros.Parameters.AddWithValue("Password", t_pass.Text);
                                zapros.Parameters.AddWithValue("Name", t_name.Text);
                                zapros.Parameters.AddWithValue("Surname", t_surname.Text);
                                zapros.Parameters.AddWithValue("Patronymic", t_pat.Text);
                                zapros.Parameters.AddWithValue("Kod_role", comboBox_post.SelectedIndex + 1);
                                zapros.Parameters.AddWithValue("Phone", maskedPhone.Text);
                                zapros.Parameters.AddWithValue("Birthday", $"{dateTime}");

                                if (zapros.ExecuteNonQuery().ToString() == "1")
                                {

                                    MessageBox.Show("Добавление прошло успешно!", "Добавление", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                    t_login.Text = "";
                                    t_pass.Text = "";
                                    t_name.Text = "";
                                    t_surname.Text = "";
                                    t_pat.Text = "";
                                    comboBox_post.Text = "";
                                    maskedPhone.Text = "";
                                    date.Text = "";
                                }
                            }

                        }
                    }
                }
                else
                {
                    MessageBox.Show("Данные сотрудника уже существуют в базе!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }


            catch
            {
                MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void b_back_Click(object sender, EventArgs e)
        {
            Employees newForm = new Employees();
            this.Hide();
            newForm.Show();
        }
        private void Employees_add_FormClosing(object sender, FormClosingEventArgs e)
        {
            Application.Exit();
        }

        private void Employees_add_Load(object sender, EventArgs e)
        {

        }
    }
}
