﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Hotel
{
    public partial class Num : Form
    {
        SqlDataAdapter dataAdapter;
        DataSet dataSet;
        public Num()
        {
            InitializeComponent();
        }

        private void b_back_Click(object sender, EventArgs e)
        {
            Main_menu_employee newForm = new Main_menu_employee();
            this.Hide();
            newForm.Show();
        }

        private void b_save_Click(object sender, EventArgs e)
        {
            Number_removal newForm = new Number_removal();
            this.Hide();
            newForm.Show();
        }

        private void b_update_Click(object sender, EventArgs e)
        {
            const string sql = "SELECT Kod_removal_numbers as 'Код',  [Kod_client] as 'Клиент', [Arrival_date] as 'Дата заезда', [Number_of_days] as 'Количество дней', [Date_of_departure] as 'Дата выезда', Price as 'Стоимость', [Kod_employee] as 'Сотрудник', [Kod_number] as 'Номер' From [Number_removal]";
            using (SqlCommand sqlCommand = new SqlCommand(sql, database.connection()))
            {
                try
                {
                    using (SqlDataReader dataReader = sqlCommand.ExecuteReader())
                    {
                        DataTable dataTable = new DataTable();
                        dataTable.Load(dataReader);
                        this.dataGridViewNumb.DataSource = dataTable;
                        dataReader.Close();
                    }
                }
                catch
                {
                    MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void Num_FormClosing(object sender, FormClosingEventArgs e)
        {
            Application.Exit();
        }

        private void Num_Load(object sender, EventArgs e)
        {
            const string sql = "SELECT Kod_removal_numbers as 'Код',  [Kod_client] as 'Клиент', [Arrival_date] as 'Дата заезда', [Number_of_days] as 'Количество дней', [Date_of_departure] as 'Дата выезда', Price as 'Стоимость', [Kod_employee] as 'Сотрудник', [Kod_number] as 'Номер' From [Number_removal]";
            using (SqlCommand sqlCommand = new SqlCommand(sql, database.connection()))
            {
                try
                {
                    using (SqlDataReader dataReader = sqlCommand.ExecuteReader())
                    {
                        DataTable dataTable = new DataTable();
                        dataTable.Load(dataReader);
                        this.dataGridViewNumb.DataSource = dataTable;
                        dataReader.Close();
                    }
                }
                catch
                {
                    MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string row = dataGridViewNumb.Rows[dataGridViewNumb.CurrentCell.RowIndex].Cells[0].Value.ToString();
              SqlCommand a = new SqlCommand($"delete from Number_removal where Kod_removal_numbers = {row} ", database.connection());
            a.ExecuteNonQuery();
            }
            catch
            {
                MessageBox.Show("Данные используются в другом документе!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            dataGridViewNumb.Refresh();
            Num nn = new Num();
            this.Hide();
            nn.Show();
        }
    }
}
