﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace Hotel
{
    public partial class Registration : Form
    {
        public Registration()
        {
            InitializeComponent();

            const string sql = "Select * from Role;";
            DataTable table = new DataTable();
            SqlCommand cmd = new SqlCommand(sql, database.connection());
            SqlDataAdapter adapter = new SqlDataAdapter();
            adapter.SelectCommand = cmd;
            adapter.Fill(table);
            DataRow[] rows = table.Select();
            for (int i = 0; i < table.Rows.Count; i++)
            {
                comboBox_role.Items.Insert(i, rows[i]["Role"]);
            }
        }

        public bool format(string a)
        {
            if (Regex.IsMatch(a.Substring(0), @"[0-9 a-z]{6,}$") == false)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        private void b_registration_Click(object sender, EventArgs e)
        {
            try
            {
                SqlCommand check1 = new SqlCommand($"select count(*) from [Employees] where [Login] like '{textBox_login_reg.Text}'", database.connection());
                //SqlCommand check2 = new SqlCommand($"select count(*) from [autorizathion] where [password] like '{textBox2.Text}'", sqlConnection);
                textBox_login_reg.Text = textBox_login_reg.Text.Trim();
                textBox_password_reg.Text = textBox_password_reg.Text.Trim();

                textBox_Name.Text = textBox_Name.Text.Trim();
                textBox_famil.Text = textBox_famil.Text.Trim();
                textBox_otc.Text = textBox_otc.Text.Trim();
                comboBox_role.Text = comboBox_role.Text.Trim();
                maskedTextBox_tel.Text = maskedTextBox_tel.Text.Trim();
                dateTimePicker_date.Text = dateTimePicker_date.Text.Trim();
                if (check1.ExecuteScalar().ToString() == "0")
                {
                    if (textBox_login_reg.Text == "" || textBox_password_reg.Text == "" || textBox_Name.Text == "" || textBox_famil.Text == "" || textBox_otc.Text == "" || comboBox_role.Text == "" || maskedTextBox_tel.Text == "" || dateTimePicker_date.Text == "")
                    {
                        MessageBox.Show("Поля не заполнены!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    else
                    {
                        if (format(textBox_password_reg.Text))
                        {
                            MessageBox.Show("Пароль должен содержать не менее 6 символов", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                        else
                        {
                            if (textBox_login_reg.Text.Contains(" ") || textBox_password_reg.Text.Contains(" "))
                            {
                                MessageBox.Show("В логине или пароле не должно быть пробелов!\nУдалите все пробелы и повторите попытку", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            else if (textBox_Name.Text.Contains(" ") || textBox_famil.Text.Contains(" ") || textBox_otc.Text.Contains(" "))
                            {
                                MessageBox.Show("В заполненных данных не должно быть пробелов!\nУдалите все пробелы и повторите попытку", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                            else
                            {
                                int mat = 0;
                                const string sql1 = "Select * from Role;";
                                DataTable table1 = new DataTable();
                                SqlCommand cmd1 = new SqlCommand(sql1, database.connection());
                                SqlDataAdapter adapter1 = new SqlDataAdapter();
                                adapter1.SelectCommand = cmd1;
                                adapter1.Fill(table1);
                                DataRow[] rows1 = table1.Select();
                                for (int i = 0; i < table1.Rows.Count; i++)
                                {
                                    if (Convert.ToString(rows1[i]["Role"]) == comboBox_role.Text)
                                    {
                                        mat = (int)rows1[i]["Kod_role"];
                                    }
                                }

                                SqlCommand zapros = new SqlCommand($"insert into [Employees] (Surname, [Name], Patronymic, Phone, Kod_role, Birthday, Password, Login) values (@Surname, @Name, @Patronymic, @Phone, @Kod_role, @Birthday, @Password, @Login)", database.connection());

                                string dateTime = dateTimePicker_date.Value.ToString("yyyy-MM-dd");
                                zapros.Parameters.AddWithValue("Login", textBox_login_reg.Text);
                                zapros.Parameters.AddWithValue("Password", textBox_password_reg.Text);
                                zapros.Parameters.AddWithValue("Name", textBox_Name.Text);
                                zapros.Parameters.AddWithValue("Surname", textBox_famil.Text);
                                zapros.Parameters.AddWithValue("Patronymic", textBox_otc.Text);
                                zapros.Parameters.AddWithValue("Kod_role", comboBox_role.SelectedIndex + 1);
                                zapros.Parameters.AddWithValue("Phone", maskedTextBox_tel.Text);
                                zapros.Parameters.AddWithValue("Birthday", $"{dateTime}");
                                if (zapros.ExecuteNonQuery().ToString() == "1")
                                {
                                    Trace.WriteLine("\nЛогин: " + textBox_login_reg.Text + "\nПароль: " + textBox_password_reg.Text + "\nФамилия: " + textBox_famil + "\nИмя: " + textBox_Name + "\nОтчество: " + textBox_otc + "\nРоль: " + comboBox_role + "\nНомер телефона: " + maskedTextBox_tel + "\nДата рождения: " + dateTimePicker_date);
                                    DebagT.diagnosticW("Успешная регистрация\nЛогин: " + textBox_login_reg.Text + "\nПароль: " + textBox_password_reg.Text + "\nФамилия: " + textBox_famil + "\nИмя: " + textBox_Name + "\nОтчество: " + textBox_otc + "\nРоль: " + comboBox_role + "\nНомер телефона: " + maskedTextBox_tel + "\nДата рождения: " + dateTimePicker_date);

                                    MessageBox.Show("Регистрация прошла успешно!", "Регистрация", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                    textBox_login_reg.Text = "";
                                    textBox_password_reg.Text = "";
                                    textBox_Name.Text = "";
                                    textBox_famil.Text = "";
                                    textBox_otc.Text = "";
                                    comboBox_role.Text = "";
                                    maskedTextBox_tel.Text = "";
                                    dateTimePicker_date.Text = "";

                                    
                                }
                            }

                        }
                    }
                }
                else
                {
                    MessageBox.Show("Вы уже зарегистрированы!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                }


            catch
            {
                MessageBox.Show("Произошла непредвиденная ошибка!", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }



            private void b_back_Click(object sender, EventArgs e)
            {
            Main_menu newForm = new Main_menu();
            this.Hide();
            newForm.Show();
            }
 
    }
}

