﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Hotel;

namespace UnitTestProject1
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void Pozitiv_proverka_symm_nomera()
        {
            string st = "2000";
            string kold = "3";
            int ex = 6000;
            Number_removal sch = new Number_removal();
            int act = sch.podsch(st, kold);
            Assert.AreEqual(ex, act);

        }

        [TestMethod]
        public void Negetiv_proverka_symm_nomera()
        {
            string st = "2000";
            string kold = "3";
            int ex = 5000;
            Number_removal sch = new Number_removal();
            int act = sch.podsch(st, kold);
            Assert.AreEqual(ex, act);
        }

        [TestMethod]
        public void Pozitive_pravilnproverka_password()
        {
            string a = "aaaaaa";
            bool ex = false;
            Registration prov = new Registration();
            bool act = prov.format(a);
            Assert.AreEqual(ex, act);
        }
        [TestMethod]
        public void Negative_pravilnproverka_password()
        {
            string a = "sss";
            bool ex = false;
            Registration prov = new Registration();
            bool act = prov.format(a);
            Assert.AreEqual(ex, act);
        }
        [TestMethod]
        public void Negative_proverka_password_and_login()
        {
            string l = "";
            string p = "sss";
            bool ex = false;
            Entrance prov = new Entrance();
            bool act = prov.logpas(p,l);
            Assert.AreEqual(ex, act);
        }
        [TestMethod]
        public void Pozotive_proverka_password_and_login()
        {
            string l = "sss";
            string p = "sss";
            bool ex = false;
            Entrance prov = new Entrance();
            bool act = prov.logpas(p, l);
            Assert.AreEqual(ex, act);
        }
    }
}
